/* C-Beispielmodul fuer Blender-Python   
 * 01.2000 M. Strubel fuers Linux-Magazin */

#include "python1.5/Python.h"

/* Merke: PyObject-Variablen werden immer als Pointer
 * deklariert: PyObject *ob;
 */

static PyObject *vertcount(PyObject *self, PyObject *args)
{
	PyObject *ob;
	int ret;
	PyObject *verts;
	
	if (!PyArg_ParseTuple(args, "O", &ob))		/* Das Argument soll ein
							   NMesh-Objekt sein - Typencheck findet
						 	   nicht statt */
		return NULL;				/* etwas ging schief...*/
	verts = PyObject_GetAttrString(ob, "verts");
	if (!verts)					/* Attribut "verts" existiert nicht..*/
	{
		return NULL;
	}
	ret = PyList_Size(verts);			/* Laenge der Liste verts[] */
	return Py_BuildValue("i", ret);			/* Und an Python zurueckgeben */
}

/* Format der Methoden-Tabelle: 
 * MethodenName, MethodenRoutine, ArgumentUebergabe, DocString 
 */
static PyMethodDef meshMethods[] = {
	{ "count", vertcount, METH_VARARGS,
		"Zaehlt die Vertices eines NMesh-Objekts"},
	{NULL, NULL, 0, NULL }
};

/* Damit wird das Modul beim Laden initialisiert */
void initmesh()
{
	PyObject *mod;

	mod = Py_InitModule("mesh", meshMethods); 	/* Modul mit seinen Methoden
							   initialisieren */
}
