/* 
 * Copyright (c) 1999, Not a Number / NeoGeo b.v. 
 * Modifications 01/2000 by onk@gmx.net
 * 
 */

#include <math.h>
#include "plugin.h"
#include <limits.h>
#include <python1.5/Python.h>

#define warn pl_warn

/* ******************** GLOBAL VARIABLES ***************** */


char name[24]= "Pyplugin";

/* structure for buttons, 
 *  butcode      name           default  min  max  0
 */

VarStruct varstr[]= {
	{LABEL,	"Python-Plugin",		0.0,	0.0, 0.0, "Demonstrate access to Python-Variables"}
};

/* The cast struct is for input in the main doit function
   Varstr and Cast must have the same variables in the same order */ 

typedef struct Cast {
	int dummy;
} Cast;

/* cfra: the current frame */

float cfra;

void plugin_seq_doit(Cast *, float, float, int, int, ImBuf *, ImBuf *, ImBuf *, ImBuf *);

/* ******************** Fixed functions ***************** */

int plugin_seq_getversion(void) 
{
	return B_PLUGIN_VERSION;
}

void plugin_but_changed(int but) 
{
}

/* globals */

PyObject *g_main, *g_int;

void plugin_init()
{
}

void plugin_getinfo(PluginInfo *info)
{
	info->name= name;
	info->nvars= sizeof(varstr)/sizeof(VarStruct);
	info->cfra= &cfra;

	info->varstr= varstr;

	info->init= plugin_init;
	info->seq_doit= (SeqDoit) plugin_seq_doit;
	info->callback= plugin_but_changed;
}

void warn(char *warning)
{
	printf("%s\n", warning);
}

void plugin_seq_doit(Cast *cast, float facf0, float facf1, int sx, int sy, ImBuf *ibuf1, ImBuf *ibuf2, ImBuf *out, ImBuf *use)
{
	int c;
	double fl;
	
	PyObject *ob, *py_float, *py_int, *mod, *cam;
	PyObject *args, *result;

	printf("\n------------------------------------------\n");
	printf("Python<->Plugin-Test\n");
	mod = PyImport_ImportModule("bplugin");
	if (!mod)
	{
		warn("Fehler: kann bplugin-Modul nicht finden");
		return;
	} 
	/* Das Python-Analogon zu: 'bplugin.varlist': */
	ob = PyObject_GetAttrString(mod, "varlist");
	if (!ob) return;
	/* Analogon zu 'varlist['pi'] */
	py_float = PyMapping_GetItemString(ob, "pi");
	if (!py_float)
	{
		warn("key 'pi' existiert nicht");
	}
	fl = PyFloat_AsDouble(py_float);
	printf("pi: %f\n", fl);
	py_int = PyMapping_GetItemString(ob, "c");
	if (!py_int)
	{
		warn("key 'c' existiert nicht");
	}
	c = PyInt_AsLong(py_int);
	printf("c: %d\n", c);
	/* Aufruf einer Methode (Funktion) des Blender-Moduls: */
	mod = PyImport_ImportModule("Blender");
	if (!mod) return; /* Das sollte eigentlich nie passieren */
	ob = PyObject_GetAttrString(mod, "Camera");
	ob = PyObject_GetAttrString(ob, "Get");
	if (!ob) return;

	/* Der Name der Kamera ist normalerweise 'Camera': */
	cam = PyObject_CallFunction(ob, "s", "Camera");
	if (!cam)
	{
		warn("Kamera nicht gefunden. Heisst sie vielleicht anders?");
		return;
	}
	py_float = PyObject_GetAttrString(cam, "Lens");
	fl = PyFloat_AsDouble(py_float);
	printf("Kamera-Lens-Wert: %f\n", fl);
}

